package smail;


public class DummyFolderContent extends smail.FolderContent
{
	private String[] subFolderNames ;
	private smail.MessageHeader[] msgHeader ;
	private String rootFolder ;

  public DummyFolderContent(String sPfad)
  {
      if (sPfad.equals("/") == true)
      {
        subFolderNames = new String[5];
        subFolderNames[0] = "/Inbox";
        subFolderNames[1] = "/Outbox";
        subFolderNames[2] = "/Sent";
        subFolderNames[3] = "/Trash";
        subFolderNames[4] = "/Draft";
      }
      if (sPfad.equals("/Inbox") == true)
      {
        subFolderNames = new String[2];
        subFolderNames[0] = "/Uni";
        subFolderNames[1] = "/Swp";
      }
      if (sPfad.equals("/Inbox/Uni") == true)
      {
        subFolderNames = new String[2];
        subFolderNames[0] = "/Gui";
        subFolderNames[1] = "/Fassade";
      }


      msgHeader = new smail.MessageHeader[5];
      for (int iCounter = 0; iCounter < 5; iCounter ++)
      {
        smail.MessageHeader mh = new smail.MessageHeader();
        mh.to = new String[2];
        mh.to[0] = "To1 "+sPfad+" "+iCounter;
        mh.to[1] = "To2 "+sPfad+" "+iCounter;
	mh.from = "Dummy@dummy.de ";
	mh.cc = new String[1] ;
        mh.cc[0] = "CC";
        mh.bcc = new String[1];
        mh.bcc[0] = "BCC";
        mh.subject = sPfad+ " "+iCounter;
        mh.folderPosition = iCounter ;
        if(iCounter > 2)
        {
            mh.attachment = false;
        }
        else
        {
            mh.attachment = true;
        }

        if(iCounter < 2)
        {
	    mh.read = false;
        }
        else
        {
	    mh.read = true;
        }

        if(iCounter == 2)
        {
	    mh.answered  = false;
        }
        else
        {
	    mh.answered  = true;
        }


        mh.rDate = "12.34.56 01.02.2001" ;
        mh.sDate = "12.22.32 01.02.2001";
        msgHeader[iCounter]= mh;
      }

      rootFolder = sPfad;
    }

    	public String getRootFolder()
	{
		return rootFolder ;
	}

	public String[] getSubFolder()
	{
		return subFolderNames ;
	}

	public smail.MessageHeader[] getMessageHeader()
	{
		return msgHeader ;
	}
  }
