package smail.filter;

/** The classes which represent a condition of a filter <b>must</b> implements 
 * this interface. <P> There is only the test-method, which is to implement.
 */
public interface Condition{ 
    
    /** this Function tests, it the Condition are true or not */
    public boolean test (javax.mail.Message msg);
	
	/** this will identify implementing classes with an associated string */
	public String getConditionType() ; 
}