package smail.filter;

public class FromCondition implements smail.filter.Condition {
    
    /** the keyword is the Stringrepresentation of the address which is searched */
    private java.lang.String    keyword;
    
    /** constructs a new FromCondtion-object
     * @param keyword a String  which  searched in the fromfield
     */
    public FromCondition (java.lang.String keyword) {
        this.keyword    = keyword;
    }
           
    /** set the keyword of the condition */
    public void setKeyword (java.lang.String key) { this.keyword = key; }
    
    /** to get the keyword of the condition */
    public java.lang.String getKeyword() { return this.keyword ; }

    /** this Function tests, it the Condition is true or not */
    public boolean test(javax.mail.Message msg) {
        javax.mail.Address[] from;
        try { from = msg.getFrom(); }
        catch (javax.mail.MessagingException e)
        {
            System.out.println("FromCondition :: MessagingException");
            return false;
        }
        if (from[0].toString().equals(this.keyword) ) return true;
        else return false;
    }    
	
	public String getConditionType()
	{
		return "FROM" ;
	}
}

