package smail.gui;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import smail.Fassade;
import smail.server.Account;

import java.util.*;


public class AccountFrame extends JFrame{

  smail.Fassade fassade = null;

  JPanel jPanel1 = new JPanel();
  JComboBox comboAccount = new JComboBox();
  JPanel jPanel2 = new JPanel();
  JTextField accountFeldName = new JTextField();
  JLabel labAccountName = new JLabel();
  JTextField userName = new JTextField();
  JLabel labUserName = new JLabel();
  JLabel labSmtp = new JLabel();
  JTextField smtpFeld = new JTextField();
  JLabel labpop = new JLabel();
  JTextField pop = new JTextField();
  JLabel labchoose = new JLabel();
  JTextField eMail = new JTextField();
  JLabel labeMail = new JLabel();
  
  JButton speichern = new JButton();
  JButton loeschen = new JButton();
  JButton schliessen = new JButton();
  JButton neu = new JButton();
  
  smail.server.Account[]  accounts;
  
	String myusername, mysmtpHost,mypop3Host, myaN, mailA;  
	
  private ResourceBundle resourceB = ResourceBundle.getBundle("smail/gui/Account_lang");
  
  private String labAccountString = resourceB.getString("labelAccount_key");
  private String labUserString = resourceB.getString("labelUser_key");
  private String labSmtpString = resourceB.getString("labelSMTP_key");
  private String labPopString = resourceB.getString("labelPOP_key");
  
  private String knoSpeichern = resourceB.getString("buttenSave_key");
  private String knoLoeschen = resourceB.getString("buttonDelete_key");
  private String knoSchliessen = resourceB.getString("buttonCancel_key");
  private String titel = resourceB.getString("titleConfig_key");
  private String labChooseString = resourceB.getString("labelInfo_key");
  private String neuAccount = resourceB.getString("buttenNew_key");
  private String labemailString = resourceB.getString("labelEmailAdre_key");
  

  public AccountFrame(smail.Fassade fassade) {

    this.fassade = fassade;
	accounts = fassade.getAllAccounts ();
	if(accounts==null || accounts.length == 0)
	{
		accounts = new Account[1];
		accounts[0]= new Account("accname","address","user","smtp","pop3");
	}	

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    jPanel1 = (JPanel) this.getContentPane();

    this.setTitle(titel);
    this.setSize(new Dimension(650, 310));
   

      Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
      this.setIconImage(image);

    jPanel1.setLayout(null);

	//comboAccount ComboBox, welche die Accounts nach Ihrem Name identifiziert
	
  comboAccount.setBounds(new Rectangle(25, 35, 200, 33));	
  	
  	
  	System.out.println("ist accounts gleich null?"+(accounts == null) ) ;
  	//if (accounts.length != 0){System.out.println("mach kein scheiss");
		for (int i =0; i<accounts.length;i++){
    		comboAccount.addItem(accounts[i]);
    	
    	}	
    
   // }			
    comboAccount.addActionListener (new ActionListener(){
    	public void actionPerformed (ActionEvent e){
    		Account acc = (Account)comboAccount.getSelectedItem();
		accountFeldName.setText(acc.accountName);
		smtpFeld.setText(acc.smtpHost);
		pop.setText(acc.pop3Host);
		userName.setText(acc.username);
		eMail.setText(acc.address);
		return;
    		}//actionPerformed
    	});
  
   
    
    //jPanel2.setBackground(Color.orange);
    jPanel2.setBounds(new Rectangle(240, 25, 388, 260));
    jPanel2.setLayout(null);
    
 
  
  	//jPanel1.setBackground(UIManager.getColor("ToolBar.dockingForeground"));
    jPanel1.setPreferredSize(new Dimension(660,310 ));
    
    accountFeldName.setBounds(new Rectangle(120, 10, 260, 26));
    accountFeldName.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent e) {
    		//myaN = accountFeldName.getText();
    		//System.out.println ("AccountName");
    	}});
    
    //labAccountName.setFont(new java.awt.Font("Dialog", 0, 14));
    labAccountName.setText("Account Name"/*labAccountString*/);
    labAccountName.setBounds(new Rectangle(10, 10, 100, 26));
    
    
    userName.setBounds(new Rectangle(120, 110, 260, 26));
    userName.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent e) {
    		//myusername = userName.getText();
    		//System.out.println ("UserName");
    	}});
    //labUserName.setFont(new java.awt.Font("Dialog", 0, 14));
    labUserName.setText(labUserString);
    labUserName.setBounds(new Rectangle(10, 110, 100, 26));
    
    
    smtpFeld.setBounds(new Rectangle(120, 210, 260, 26));
    smtpFeld.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent e) {
    		//mysmtpHost = smtpFeld.getText();
    		//System.out.println ("Smtp");
    	}});
    //labSmtp.setFont(new java.awt.Font("Dialog", 0, 14));
	labSmtp.setText(labSmtpString);
    labSmtp.setBounds(new Rectangle(10, 210, 100, 26));
  
  
    pop.setBounds(new Rectangle(120, 160, 260, 26));
	pop.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent e) {
    		//mypop3Host = pop.getText();
    		//System.out.println ("POP");
    	}});
    
    //labpop.setFont(new java.awt.Font("Dialog", 0, 14));
    labpop.setText(labPopString);
    labpop.setBounds(new Rectangle(10, 160, 100, 26));
    
    eMail.setBounds (new Rectangle (120,60,260,26));
    eMail.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent e) {
    		//mailA = eMail.getText();
    		//System.out.println ("MailAdress");
    	}});
    //labeMail.setFont (new java.awt.Font("Dialog",0,14));
    labeMail.setText (labemailString);
    labeMail.setBounds (new Rectangle(10, 60, 100, 26));
    
    labchoose.setFont(new java.awt.Font("Dialog", 2, 14));
    labchoose.setText(labChooseString);
    labchoose.setBounds(new Rectangle(25, 10, 160, 26));
    
    speichern.setText(knoSpeichern);
    speichern.setBounds(new Rectangle(25, 85, 200, 33));
    speichern.addActionListener (new ActionListener (){
    	public void actionPerformed (ActionEvent e){
		//System.out.println("myaN        "+myaN      );
		//System.out.println("mailA       "+mailA     );
		//System.out.println("myusername  "+myusername);
		//System.out.println("mysmtpHost  "+mysmtpHost);
		//System.out.println("mypop3Host  "+mypop3Host);
    		try{
    			for (int i =0; i<accounts.length;i++){
    				if(accounts[i].accountName.equals(accountFeldName.getText())){
    					fassade.updateAccount(accountFeldName.getText(), eMail.getText() , userName.getText(), smtpFeld.getText(),pop.getText());
    					return;
    				}//if
    			}//for
    		
    			fassade.addAccount (accountFeldName.getText(), eMail.getText() , userName.getText(), smtpFeld.getText(),pop.getText());
    			accounts = fassade.getAllAccounts ();
    			System.out.println ("Account wird gespeichert");
    			for (int i =0; i<accounts.length;i++){
    				if (! isItem(comboAccount, accounts[i])){
    				
    				comboAccount.addItem(accounts[i]);
    				};
    			}//for	
    
    			
    		}//try
    

    		catch (smail.server.InvalidAccountName irgendwas) {System.out.println("Invalid Account Name");}
    	}});
    
    loeschen.setText(knoLoeschen);
    loeschen.setBounds(new Rectangle(25, 185, 200, 33));
    loeschen.addActionListener (new ActionListener (){
    	public void actionPerformed (ActionEvent e){
    		Account acc = (Account)comboAccount.getSelectedItem();
    		comboAccount.removeItem(acc);
		fassade.removeAccount(acc.accountName);
    		accounts = fassade.getAllAccounts ();
    		//for (int i =0; i<accounts.length;i++){
 	   	//	comboAccount.addItem(accounts[i]);
    		//}
    	}});
    
    schliessen.setText(knoSchliessen);
    schliessen.setBounds(new Rectangle(25, 235, 200, 33));
    schliessen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        schliessen_actionPerformed(e);
      }
    });
    neu.setText(neuAccount);
    neu.setBounds(new Rectangle (25, 135, 200, 33));
    neu.addActionListener (new ActionListener (){
    	public void actionPerformed (ActionEvent e){
    		pop.setText("");
 		//new PassWordEnter();
    		smtpFeld.setText("");
    		userName.setText("");
    		accountFeldName.setText("");
    		eMail.setText("");
    		}
    	});
     
    

    jPanel1.add(jPanel2, null);
    jPanel2.add(accountFeldName, null);
    jPanel2.add(labUserName, null);
    jPanel2.add(labAccountName, null);
    jPanel2.add(labSmtp, null);
    jPanel2.add(labpop, null);
    jPanel2.add(pop, null);
    jPanel2.add(smtpFeld, null);
    jPanel2.add(userName, null);
    jPanel2.add(eMail, null);
    jPanel2.add(labeMail, null);
    jPanel1.add(labchoose, null);
    jPanel1.add(comboAccount, null);
    jPanel1.add(schliessen, null);
    jPanel1.add(loeschen, null);
    jPanel1.add(speichern, null);
    jPanel1.add(neu,null);
    
  }
public boolean  isItem (JComboBox box, Account account){
    	for (int j =0; j<box.getItemCount();j++){
    		if(account.equals(box.getItemAt(j))){
		 	return true;
		}	
	}	 	
	return false;
}

  void schliessen_actionPerformed(ActionEvent e)
  {
    dispose();
  }
  
  
  
  
  
}
