
/**
 * berschrift: Sm@il GUI<p>
 * Beschreibung: The Graphical User Inter for the e-mail client Sm@il<p>
 * Copyright: Copyright (c) Team GUI<p>
 * Organisation: Borg-Collective<p>
 * @author Team GUI
 * @version 1.0
 */
package smail.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

public class GroupButtonSkins extends JPanel {
  smail.Fassade fassade;
  
  public GroupButtonSkins(smail.Fassade fsd) {
    super(new GridLayout(5,1, 2,2));
	this.fassade = fsd;

    // setting the language
    String language = "Deutsch";

    // defining the needed Components
    JPanel folderPanel, mailsPanel, contentPanel, centerPanel, buttonPanel, pwb, pwn,pwc, pws, pwa;
    JButton buttonNewMail, buttonSendMail, buttonLoadMail, buttonLoadNSendMail, buttonEditAccounts, buttonAdress, buttonFilter, buttonExit;

    // arrangeing the panels and frames
    add(pwb = new JPanel(new GridLayout(1,1, 2,2)), BorderLayout.BEFORE_FIRST_LINE);
    add(pwn = new JPanel(new GridLayout(2,1, 2,2)), BorderLayout.NORTH);
    add(pwc = new JPanel(new GridLayout(1,1, 2,2)), BorderLayout.CENTER);
    add(pws = new JPanel(new GridLayout(2,1, 2,2)), BorderLayout.SOUTH);
    add(pwa = new JPanel(new GridLayout(2,1, 2,2)), BorderLayout.AFTER_LAST_LINE);

    // setting up and adding the buttons for German language
if (language == "Deutsch") {pwc.add(buttonNewMail = new JButton("Neue Mail"));
    pwb.add(buttonLoadNSendMail = new JButton("senden/empfangen"));
    pwn.add(buttonSendMail = new JButton("senden"));
    pwn.add(buttonLoadMail = new JButton("abrufen"));
    pws.add(buttonAdress = new JButton("Adressbuch"));
    pws.add(buttonEditAccounts = new JButton("Accounts"));
    pwa.add(buttonFilter = new JButton("Filter"));
    pwa.add(buttonExit = new JButton("Beenden"));}

    // setting up and adding the buttons for English language
else {pwc.add(buttonNewMail = new JButton("new mail"));
    pwb.add(buttonLoadNSendMail = new JButton("receive/send"));
    pwn.add(buttonSendMail = new JButton("send"));
    pwn.add(buttonLoadMail = new JButton("receive"));
    pws.add(buttonAdress = new JButton("adressboock"));
    pws.add(buttonEditAccounts = new JButton("accounts"));
    pwa.add(buttonFilter = new JButton("filters"));
    pwa.add(buttonExit = new JButton("quit"));}

    // creating JTables to contain the e-mail data
/*    TableModel dataModel = new AbstractTableModel() {
      public int getColumnCount() { return 5; }
      public int getRowCount() { return 15;}
      public Object getValueAt(int row, int col) { return new Integer(row*col); }
    };
    JTable mailTable = new JTable(dataModel);
    JTable contentTable = new JTable(dataModel);
    JScrollPane mailScrollPane = new JScrollPane(mailTable);
    JScrollPane contentScrollPane = new JScrollPane(contentTable);
/*    frameMails.getContentPane();
    this.add(mailScrollPane);
    frameContent.getContentPane();
    this.add(contentScrollPane);*/

    // defining the ActionListeners for the buttons
    buttonNewMail.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Editor Fenster ffnen");
         EditorFrame editor = new EditorFrame(fassade,"","","bla.de");
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        editor.setVisible(true);
      }
    });
    buttonSendMail.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Mail versendet");
	JProgressBar jProgressBar = new JProgressBar();
	// jProgressBar.isVisible(true);
	fassade.send();
	// jProgressBar.dispose();
      }
    });
    buttonLoadMail.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Mails abgerufen");
	fassade.receive();
      }
    });
    buttonLoadNSendMail.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Mails abgerufen und versendet");
	fassade.send();
	fassade.receive();
      }
    });
    buttonEditAccounts.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Mails abgerufen");

    boolean packFrame = false;
    AccountFrame frame = new AccountFrame(fassade);

    //Pack frames that have useful preferred size info, e.g. from their layout
    //Validate frames that have preset sizes
    if (packFrame)
      frame.pack();
    else
      frame.validate();

    // Center the frame
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

    frame.setVisible(true);
      }
    });
    buttonFilter.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Filter Fernster ffnen");
      }
    });
    buttonAdress.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Adressbuch Fernster ffnen");
	Addressbook ab = new Addressbook(fassade);
      }
    });
    buttonExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.out.println("Gui Exit");
        System.exit(0);
      }
    });
  }
}
