package smail.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.text.*;

public class ViewMessagePane extends JTextPane implements HyperlinkListener
{

    smail.Fassade fassade = null;

    MouseEvent mouseEvent = null;

    String sPropertieFile = "";
    String sId = "";
    String sAufruf = "";

    // property-File for chosing language (view_lang_en for english, view_lang_de for german)
    private ResourceBundle resource = ResourceBundle.getBundle("smail/gui/view_lang");

    // getting the language specific textes for buttons, menus, etc from the property-file

    private String sMenuMessageNew = resource.getString("menuMessageNew_key");
    private String sMenuAddressbookOpen = resource.getString("menuAddressbookOpen_key");

    // Popup menus
    JPopupMenu jPopupMenuAddress = new JPopupMenu();
    JMenuItem jPopupMenuAddressEditor = new JMenuItem(sMenuMessageNew);
    JMenuItem jPopupMenuAddressAddressbook = new JMenuItem(sMenuAddressbookOpen);



  // Smiley-Hilfsfunktion
    private String changeHTMLSmilie(String sContent, java.net.URL SmilieFile) // sContent in html-format
    {
            // Smilies einbauen
            Smilie smilie = new Smilie();
            String sBefore = null;
            String sAfter = null;
            String sSmiley = null;
	    try {	
//        	    ReadFileByLines rfbl = new ReadFileByLines(SmilieFile);
        	    java.io.BufferedReader rfbl = new java.io.BufferedReader(new java.io.InputStreamReader(SmilieFile.openStream()));
        	    String sActualSmilie = rfbl.readLine(); // erste zeile holen der smilieliste holen
        	    while (sActualSmilie != null)
        	    {
        	      int iIndex =  sContent.indexOf(sActualSmilie); // stelle des ersten smilies suchen
        	      while (iIndex > -1)
        	      {
                	  smilie.setSize(15,15);
                	  String sName = smilie.getSmilie(sActualSmilie); // pfad+dateiname holen
                	  if(sName != null)
                	  {
	                	  sSmiley = "<img src=\""+sName+"\">"; // erzeugen eines html-smileys
    	        	      sBefore = sContent.substring(0, iIndex);
        	        	  sAfter = sContent.substring(iIndex + sActualSmilie.length(), sContent.length());
            		      sContent = sBefore + sSmiley + sAfter;
                		  iIndex =  sContent.indexOf(sActualSmilie);
                	  }
                	  else break;
        	      }
        	      sActualSmilie = rfbl.readLine(); // naechste zeile holen, dh. naechsten smiley holen
        	    }
        	    rfbl.close();
		}    
	        catch(java.io.IOException ioe)
	        {
	        	System.out.println("ViewMessageFrame: Problem reading Smilie.txt");
	        }	
        	return sContent;
		    
    }

    private String replaceHyperlink(String sText)
    {
        String sTempBig = sText.toUpperCase();
        String sTemp = sText;

        String sBefore = null;
        String sAfter = null;
        String sLink = null;
        String sHyperlink = null;
        String sNewText = sText;
        int iEnd = -1;

        int iIndex =  sTempBig.indexOf("HTTP://"); // stelle des ersten links suchen

        while (iIndex > -1)
        {
            iEnd = sTempBig.indexOf(" ",iIndex);

            if(sTempBig.indexOf("\n",iIndex)<iEnd)
            {
              iEnd = sTempBig.indexOf("\n",iIndex);
            }

            if(sTempBig.indexOf("<",iIndex)<iEnd)
            {
              iEnd = sTempBig.indexOf("<",iIndex);
            }

            if(iEnd==-1)
            {
              iEnd = sTempBig.length();
            }
            sLink = sTemp.substring(iIndex,iEnd);

            // noch kein echter Link!!!
            sHyperlink = "<a href=\""+sLink+"\">"+sLink+"</a>"; // erzeugen eines hyperlinks

            sBefore = sTemp.substring(0, iIndex);
            sAfter = sTemp.substring(iIndex+sLink.length(), sTemp.length()); //+7 damit http weg ist
            sNewText = sBefore + sHyperlink + sAfter;
            sTempBig = sNewText.toUpperCase();
            sTemp = sNewText;
            iIndex =  sTempBig.indexOf("HTTP://",iIndex+sHyperlink.length()); // weitersuchen
        }

      return sNewText;
    }





    private String replaceAddress(String sText)
    {
        String sTemp = sText;

        String sBefore = null;
        String sAfter = null;
        String sLink = null;
        String sHyperlink = null;
        String sNewText = sText;
        int iEnd = -1;
        int iBegin = -1;
        int iTemp = -1;

        int iIndex =  sTemp.indexOf("@"); // stelle des ersten links suchen

        while (iIndex > -1)
        {
            // Ende des Links finden
            iEnd = sTemp.indexOf(" ",iIndex);

            if(iEnd == -1)
            {
              iEnd = sTemp.length();
            }

            iTemp = sTemp.indexOf("\n",iIndex);

            if((iTemp>-1)&&(iTemp<iEnd))//sTemp.indexOf("\n",iIndex)<iEnd)
            {
              iEnd = sTemp.indexOf("\n",iIndex);
            }

            iTemp = sTemp.indexOf("<",iIndex);

            if((iTemp>-1)&&(iTemp<iEnd))//sTemp.indexOf("\n",iIndex)<iEnd)
            {
              iEnd = sTemp.indexOf("<",iIndex);
            }

            // Anfang des Links finden
            iBegin = sTemp.lastIndexOf(" ",iIndex);

            if(sTemp.lastIndexOf("\n",iIndex)>iBegin)
            {
              iBegin = sTemp.lastIndexOf("\n",iIndex);
            }

            if(sTemp.lastIndexOf(">",iIndex)>iBegin)
            {
              iBegin = sTemp.lastIndexOf(">",iIndex);
            }

            if(iBegin==-1)
            {
              iBegin = 0;
            }

            // adresse rausschneiden
            sLink = sTemp.substring(iBegin+1,iEnd);

            // LinkAdresse erzeugen
            sHyperlink = "<a href=\""+sLink+"\">"+sLink+"</a>";

            // Text zusammenfuegen mit Linkadresse
            sBefore = sTemp.substring(0, iBegin+1);
            sAfter = sTemp.substring(iEnd, sTemp.length());
            sNewText = sBefore + sHyperlink + sAfter;
            sTemp = sNewText;
            iIndex =  sTemp.indexOf("@",iIndex+sHyperlink.length());
        }

      return sNewText;
    }


    public void hyperlinkUpdate(HyperlinkEvent event)
    {
      if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
      {
          System.out.println("URL: "+event.getDescription());

          sAufruf = event.getDescription(); // global machen
          String sAufrufLowerCase = sAufruf.toLowerCase();
          if ((sAufrufLowerCase.indexOf("http")!= -1)||(sAufrufLowerCase.indexOf("file")!= -1))
          {
            Internet browser = new Internet(sAufruf);
            browser.show(sAufruf);
          }
          else
          {
            if ((mouseEvent.getModifiers() != InputEvent.BUTTON1_MASK))
            {
              // rechte Maustaste
              jPopupMenuAddress.show(mouseEvent.getComponent(), mouseEvent.getX(), mouseEvent.getY());
            }
            else
            {
              // linke Maustaste
              EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",sAufruf);
              editor.show();
            }
          }

      }
    }




  // speichern des Mouseevents (fuer hyperlink popup)
  void this_mousePressed(MouseEvent e)
  {
    mouseEvent = e;
  }

  // Popup Address -> Editor
  void jPopupMenuAddressEditor_actionPerformed(ActionEvent e)
  {
      EditorFrame editor = new EditorFrame(fassade,"pfad/zur/PropertieDatei.txt", "id", "bla@bla.de",sAufruf);
      editor.show();
  }

    // Addressbook -> Open Addressbook
    void jPopupMenuAddressAddressbook_actionPerformed(ActionEvent e)
    {
        Addressbook book = new Addressbook(fassade);
        book.show();
    }



  public ViewMessagePane(smail.Fassade fassade, String sPropertieFile, String sId,String sText)
  {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try
        {
            this.fassade = fassade;

            this.setBackground(Color.white);
            this.setSelectionColor(SystemColor.black);
            this.setEditable(false);
            this.setBorder(BorderFactory.createEtchedBorder());
            this.setFont(new java.awt.Font("Serif", 0, 13));


            String sTemp = sText.trim().toUpperCase();
            java.net.URL sTempResource = smail.gui.ViewMessageFrame.class.getResource("smilie.txt");

            if ((sTemp.indexOf("<HTML>")==0)||(sTemp.indexOf("<!DOCTYPE HTML")==0))
            {
	     System.out.println("In GUI (is HTML): "+sText);
	      sText = "<HTML><PRE>"+sText+"</PRE></HTML>";
              javax.swing.text.html.HTMLEditorKit eKit = new javax.swing.text.html.HTMLEditorKit();
              this.setEditorKit(eKit);
              String sContent = changeHTMLSmilie(sText, sTempResource); // linux: /user/home/...

              //sContent = replaceHyperlink(sContent); // hyperlinks erzeugen
              this.setText(sText);
            }
            else
            {
              javax.swing.text.html.HTMLEditorKit eKit = new javax.swing.text.html.HTMLEditorKit();
              this.setEditorKit(eKit);

	      this.setText("<HTML><PRE>"+sText+"</PRE></HTML>");
              String sContent = changeHTMLSmilie(this.getText(),sTempResource);
              sContent = replaceHyperlink(sContent);
              sContent = replaceAddress(sContent);
              this.setText(sContent);
            }

            this.addHyperlinkListener(this);
            this.addMouseListener(new java.awt.event.MouseAdapter(){public void mousePressed(MouseEvent e){this_mousePressed(e);}});

            jPopupMenuAddressEditor.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jPopupMenuAddressEditor_actionPerformed(e);}});
            jPopupMenuAddressAddressbook.addActionListener(new java.awt.event.ActionListener(){public void actionPerformed(ActionEvent e){jPopupMenuAddressAddressbook_actionPerformed(e);}});

            jPopupMenuAddress.add(jPopupMenuAddressEditor);
            jPopupMenuAddress.add(jPopupMenuAddressAddressbook);

        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

  }
}
