/*
 * LocalMessage.java
 *
 * Created on 25. Mai 2001, 20:33
 */

package smail.localStore;

public class LocalMessage extends javax.mail.internet.MimeMessage {
  
  private java.util.Date received = null;
  
  
  
  public LocalMessage(javax.mail.Session s) { super(s); }
  
  public LocalMessage(javax.mail.Session s, java.io.InputStream i) throws javax.mail.MessagingException
  { super (s,i); }
  
  // new javax.mail.internet.MimeMessage(
  
  public LocalMessage(javax.mail.internet.MimeMessage msg) 
  throws javax.mail.MessagingException {
    super(msg);
  }
  
  public LocalMessage(javax.mail.Folder f, java.io.InputStream is, int i) throws javax.mail.MessagingException {
    super(f, is, i);
  }
  
  protected void setExpunged(boolean x) { super.setExpunged(x); }
  
  protected void setMessageNumber(int nr) { super.setMessageNumber(nr); }
  
  public java.util.Date getReceivedDate() throws javax.mail.MessagingException {
    // TODO: here's something deprecated. Find and kill it :-)
    String[] dateHeader = this.getHeader("Date");
    if (dateHeader != null && dateHeader.length != 0) {
//      System.out.println("LocalMessage.getReceivedDate(): " + dateHeader[0]); // debug
      return new java.util.Date(dateHeader[0]);
    }
//    System.out.println("FIXME: LocalMessage.getReceivedDate(): no date found"); // debug
    return new java.util.Date();
  }
}
