package smail.server;

import java.lang.reflect.*;
import java.io.*;
import javax.mail.*;
import javax.activation.*;
import javax.mail.internet.*;
import java.net.*;

//Wraps the Link to a File into a new BodyPart-Object

public class Attachement extends MimeBodyPart
{
	File attfile;
	
	public Attachement(String path)
	{
		attfile = new File(path);             
	}
                   	
    // Create AttachementBodyPart               	
                   	
    public void fillAtt() throws FileNotFoundException
    {
    	if (attfile.isFile())
    	{
    	 		DataSource src = null;
    	 		boolean local = false;
    	 		File [] roots = File.listRoots();   	
    	    	for (int i = 0;i < roots.length;i++)
    	    	{
    	    		if (roots[i].getPath().charAt(0) == attfile.getPath().charAt(0))
    	    		{
    	    			src = new FileDataSource(attfile);
    	       			local = true;
    	       			break;
    	       		}
    	       	}
    	       	if (!local)
    	       	{ 
    	       		try
    	       		{
    	       			src = new URLDataSource(attfile.toURL());
    	       		}
    	       		catch(MalformedURLException mfue)
    	       		{
    	       			System.out.println("URL not found");
    	       		}
    	       	}
    	       	
    	       	try
    	       	{
    	       		this.setDataHandler(new DataHandler(src));
    	      		this.setFileName(makeFileofPath(attfile));
    	      	}
    	      	catch(MessagingException mex)
    	      	{
    	      		System.out.println(mex.getMessage());
    	      	}
    	      	catch(FileNotFoundException fnfe)
    	      	{
    	    		fnfe = new FileNotFoundException("Path without File");
    	    		System.out.println(fnfe);
    	    	}
    	}
    	else
    	{
    	   throw new FileNotFoundException("Path without File");
    	}
    }	
	
	public static Attachement makeAttachement(String path) throws FileNotFoundException
	{
		Attachement att = new Attachement(path);
		try
		{
			att.fillAtt();
			att.setDisposition(Part.ATTACHMENT);
		}
		catch(FileNotFoundException fex)
		{
			fex = new FileNotFoundException("Path witout File");
		}
		catch(MessagingException mex)
		{
			System.out.println(mex.getMessage());
		}
		return att;
	}
		
	public static String makeFileofPath(File path) throws FileNotFoundException
	{
			System.out.println("Path " + path.toString());
			String filename = null;
			int i = 0;
			int j = 0;
			char[] temp = new char[path.getPath().length()]; 
			while (i < path.getPath().length())
			{ 
				if (path.getPath().charAt(i) != path.separator.charAt(0))
				{
					System.out.println("letter of path " + path.getPath());//.charAt(i));
					System.out.println("letter of path " + path.getPath().charAt(i));
					System.out.println("seperator " + path.separator.charAt(0));
					temp [j] = path.getPath().charAt(i);
					/*for (int k = 0;k < temp.length;k++)
					{
						System.out.println("chararrayelem" + Array.getLong(temp,k));
					}*/
					System.out.println("tl" + temp.length);
					filename = new String(Attachement.trimString(temp));
					
					System.out.println("Filename= " + filename);
					System.out.println("Filenamelength= " + filename.length());
					j++;
				}
				else
				{
					j = 0;
					System.out.println("temp Charat(2)" + temp[2]);
					temp = null;
					if (filename != null)
					{
						temp = new char[(path.getPath().length()) - (filename.length())];
						filename = null;
					}
					else
					{
						temp = new char[(path.getPath().length())];
					}
					//System.out.println((path.getPath().length()));
					//System.out.println((filename.length()));
					//System.out.println("zapp" + ((path.getPath().length()) - (filename.length())));
				}
				i++;
			}
			
			if (filename == null)
			{
				throw new FileNotFoundException("Path without File");
			}
			System.out.println("Filename in Attachement.java " + filename);
			return filename;
	}
	
	public static String trimString(char [] toTrim)
	{
		int i = 0;
		char [] tmp = null;
		if (toTrim[(toTrim.length-1)] == 0)
		{
			while (Array.getLong(toTrim,i) != 0)
			{
				tmp = new char [i+1];
				for (int j = 0;j <= i;j++)
				{
					tmp[j] = toTrim[j];
				}
				//System.out.println("arraylength" + tmp.length);
				i++;
			}
			return new String(tmp);
		}
		else return new String(toTrim);
	}			
}                    
                    

                                        