package smail.server;

//import smail.localStore.*;
//import java.lang.*;
//import javax.mail.*;
//import java.util.*;
//import javax.mail.internet.*;
//import javax.activation.*;

public class FetchMail
{

    public static smail.localStore.LocalMessage[] getMails(Account acc, boolean del) throws javax.mail.NoSuchProviderException
    {
        smail.localStore.LocalMessage[] messages = null;
        try
        {
            //Get systemproperties
            java.util.Properties props = System.getProperties();
            
            //Add accounts properties to systemproperties and save in props
            props.setProperty("mail.user",acc.username);
            props.setProperty("Password",acc.password);
            props.setProperty("mail.store.protocol",acc.rcptprot);
            props.setProperty("mail.transport.protocol",acc.transferprot);
            props.setProperty("mail.smtp.host",acc.smtpHost);
            props.setProperty("mail.pop3.host",acc.pop3Host);
            
            javax.mail.Session session = javax.mail.Session.getInstance(props);
            
            // Get the store
            javax.mail.Store store = session.getStore(acc.rcptprot);
            
            store.connect(acc.pop3Host,acc.username,acc.password);
            
            // Get folder
            if (acc.rcptprot.equals("pop3") || acc.rcptprot.equals("POP3"))
            {
                //mailboxes = new Folder [1];
                javax.mail.Folder tempFolder = store.getFolder("INBOX");
                tempFolder.open(javax.mail.Folder.READ_ONLY);
                //System.out.println("DEBUG: smail.server.Fetchmail: Folder :"+ mailboxes[0] +" geffnet");
                messages =  new smail.localStore.LocalMessage[tempFolder.getMessages().length];
                for (int i=0; i<messages.length; i++)
                    messages[i] = new smail.localStore.LocalMessage((javax.mail.internet.MimeMessage)tempFolder.getMessages()[i]);
            }
            else
            {
                if (acc.rcptprot.equals("IMAP") || acc.rcptprot.equals("imap"))
                {
                    //					try
                    //					{
                    javax.mail.Folder[] persFolderOnServer = store.getPersonalNamespaces();
                    
                    //javax.mail.Folder[] tempFolderArray;
                    java.util.Vector folderVector = new java.util.Vector();
                    
                    for (int i=0; i<persFolderOnServer.length; i++)
                    {
                        javax.mail.Message[] temp = persFolderOnServer[i].getMessages();
                        for (int j=0; j<temp.length;j++)
                            folderVector.add(temp[j]);
                    }
                    messages = (smail.localStore.LocalMessage[]) folderVector.toArray();
/*                        for (int j=0; i< tempFolderArray.length;i++)
                        {
                            
                            javax.mail.Message[] folderMsgs = tempFolderArray[j].getMessages();
                            for (int k=0; i<folderMsgs.
                            folderVector.add(new smail.localStore.LocalMessage(tempFolderArray[i]);
                    }
                    
  */                  //					}
                    //					catch(NullPointerException nux)
                    //					{
                    //						nux = new NullPointerException("No mailboxes found");
                    //					}
                }
            }
            store.close();

        }
        catch(javax.mail.MessagingException e)
        {
			if (e.getMessage().startsWith("Connect failed")) {
				String[] msg =  { "Please check the connection to the mail-server",
						"smail is unable to resolv the host address" 
				};
				smail.Popup p = new smail.Popup(msg,true) ;
			}
			else {
				e.printStackTrace();				
			}
            //			System.out.println("FetchMail wirft
            //System.out.println("MessagingException");
            //System.out.println(mex.getMessage());
        }
        return messages;
        
    }
        //download();
/*		if (myacc.rcptprot.equals("pop3") || myacc.rcptprot.equals("POP3"))
                {}
                else
                {
                        if (acc.rcptprot.equals("IMAP") || acc.rcptprot.equals("imap"))
                        {
                                try
                                {
                                        Store store = session.getStore(acc.rcptprot);
                                        Folder inbox = store.getFolder("INBOX");
                                        inbox = FetchMail.cp2INBOX(mailboxes);
                                        getMails(inbox,false);
 
                                }
                                catch(MessagingException mex)
                                {
                                        mex = new MessagingException("INBOX not available");
                                }
                        }
                        else
                        {
                                throw new NoSuchProviderException("Protokoll not supported by Smail");
                        }
                }
                System.out.println("messages ist null ?"+(messages == null)) ;
 *//*		if (messages != null)
                {
    
                        smail.localStore.LocalMessage [] lma = new smail.localStore.LocalMessage [messages.length];
                        for (int i = 0; i < messages.length;i++)
                        {
                                if (messages[i] instanceof javax.mail.internet.MimeMessage)
                                {
                                        try
                                        {
                                                lma[i] = new smail.localStore.LocalMessage((MimeMessage) messages[i]);
                                        }
                                        catch(MessagingException mex)
                                        {
                                                mex = new MessagingException("No valid Content in FetchMail.messages["+i+"]");
                                        }
                                }
                        }
                        if (del == true)
                                {
                                        for (int i = 0;i < mailboxes.length;i++)
                                        {
                                                try
                                                {
                                                        Message [] deleteem = mailboxes[i].getMessages();
                                                        for (int j = 0;j < deleteem.length;j++)
                                                        {
                                                                deleteem[j].setFlag(Flags.Flag.DELETED, true); // set the DELETED flag
                                                        }
                                                        mailboxes[i].expunge();
                                                }
                                                catch (MessagingException mex)
                                                {
                                                        mex = new MessagingException("No Messages available");
                                                }
                                        }
                                }
                        return lma;
                }
                else
                {
                        return new LocalMessage[0] ;
                }
        }
    */
/*	public static Folder [] getMailboxes(Account acc)
        {
                FetchMail fm = new FetchMail(acc);
                return fm.mailboxes;
        }
 */
    }
/*=======
package smail.server;
 
import java.lang.*;
import javax.mail.*;
import java.util.*;
import javax.mail.internet.*;
import javax.activation.*;
 
public class FetchMail
{
    /*public static javax.mail.Message[] fetchMail(smail.server.Account acc) throws javax.mail.NoSuchProviderException, javax.mail.MessagingException
    {
 
        java.util.Properties props = System.getProperties ();
 
                props.setProperty("mail.user",acc.username);
                props.setProperty("Password",acc.password);
                props.setProperty("mail.store.protocol",acc.rcptprot);
                props.setProperty("mail.transport.protocol",acc.transferprot);
                props.setProperty("mail.smtp.host",acc.smtpHost);
                props.setProperty("mail.pop3.host",acc.pop3Host);
        javax.mail.Store store = javax.mail.Session.getDefaultInstance(props).getStore("POP3");
        store.connect(acc.pop3Host,acc.username,acc.password);
        return store.getDefaultFolder().getMessages();
    }
 
}
 
        Account 	myacc;
        Session 	session;
        MimeMessage 	msg;
        Properties 	props;
        String 		from;
        String 		to;
        String		subject;
        Folder  []	mailboxes;
        Message []      messages;
 
 
        public FetchMail(Account acc)
        {
                Exception ex;
                this.mailboxes = null;
                try
                {
                        myacc = acc;
 
                        //Get systemproperties
                        props = System.getProperties();
 
                        //Add accounts properties to systemproperties and save in props
                        props.setProperty("mail.user",acc.username);
                        props.setProperty("Password",acc.password);
                        props.setProperty("mail.store.protocol",acc.rcptprot);
                        props.setProperty("mail.transport.protocol",acc.transferprot);
                        props.setProperty("mail.smtp.host",acc.smtpHost);
                        props.setProperty("mail.pop3.host",acc.pop3Host);
 
                        //Creating new Session-object
                        session = Session.getInstance(props);
 
                        // Get the store
 
 
 
                        Store store = session.getStore(acc.rcptprot);
 
                        store.connect(myacc.pop3Host,myacc.username,myacc.password);
 
                        // Get folder
                        if (acc.rcptprot.equals("pop3") || acc.rcptprot.equals("POP3"))
                        {
                                mailboxes = new Folder [1];
                                mailboxes[0] = store.getFolder("INBOX");
                                System.out.println("Folder :"+mailboxes[0]+" geffnet");
                                this.messages = getMails(mailboxes[0]);
                        }
                        else
                        {
                                if (acc.rcptprot.equals("IMAP") || acc.rcptprot.equals("imap"))
                                {
                                        try
                                        {
                                                Folder [] mboxes = store.getPersonalNamespaces();
                                                mailboxes = new Folder [mboxes.length];
                                                for (int i = 0;i < mboxes.length;i++)
                                                {
                                                        mailboxes[i] = mboxes[i];
                                                }
                                        }
                                        catch(NullPointerException nux)
                                        {
                                                System.out.println( "FetchMail.FetchMail() :: caught NullPointerException" ) ;
                                                System.out.println( "message is :"+nux.getMessage() ) ;
//						nux = new NullPointerException("No mailboxes found");
                                        }
                                }
                        }
 
                        store.close();
                }
                catch(MessagingException mex)
                {
                        System.out.println( "FetchMail.FetchMail() :: caught MessagingException near end of method message is :" ) ;
                        System.out.println( mex.getMessage() ) ;
                        System.out.println( "-----END" ) ;
                        if ( mex.getMessage().startsWith("Connect failed") ) {
                                String[] msg = new String[] {
                                        "Please check whether you are connected to some kind of network.",
                                        "smail cannot resolv the spezified mail host !"
                                } ;
                                smail.Popup p = new smail.Popup(msg, true) ;
                        }
                        else {
                                smail.Popup p = new smail.Popup( mex.getMessage(),true ) ;
                        }
                }
                //catch(NoSuchProviderException nox)
                //{
                //	nox = new NoSuchProviderException();
                //	System.out.println("Protocol not supported on this Server " + nox.getMessage());
                //}
        }
 
        public Message [] getMails(Folder f) throws NullPointerException
        {
                this.messages = null;
                // Get directory
                try
                {
                        f.open(Folder.READ_WRITE);
                        javax.mail.Message[] msgTemp = f.getMessages();
                        this.messages = new javax.mail.Message[msgTemp.length];
                        System.out.println(msgTemp.length);
                        for (int i=0; i < msgTemp.length;i++)
                        {
                                if (msgTemp[i] instanceof javax.mail.internet.MimeMessage)
                {
                                        messages[i] = new MimeMessage((MimeMessage) msgTemp[i]);
 
                                        // sets the deleted flag
                        //msgTemp[i].setFlag(Flags.Flag.DELETED,true);
                }
                                else System.out.println("keine MimeMessage");
                        }
                        // Close connection
                        f.close(true);
                }
                catch(MessagingException mex)
                {
                        System.out.println( "FetchMail.getMails(folder) :: caught MessagingException " ) ;
                        System.out.println( "		message is :"+mex.getMessage() ) ;
                        throw new NullPointerException() ;
                }
                if (this.messages == null)
                {
                        System.out.println( "Fetch.getMails() :: throwing new NullPointerException"  ) ;
                        throw new NullPointerException("No Messages in this Folder");
                }
                System.out.println("Messages abgerufen");
 
                return this.messages;
        }
 
        public static Folder cp2INBOX(Folder [] mailbs)
        {
                for (int i = 0;i < mailbs.length;i++)
                {
                        if (i == 0)
                        {}
                        else
                        {
                                try
                                {
                                        mailbs[0].appendMessages(mailbs[i].getMessages());
                                }
                                catch(NullPointerException npe)
                                {
                                        System.out.println( "FetchMail.cp2Inbox() :: caught Nullpointer" ) ;
                                        npe = new NullPointerException("Mailbox " + i + "empty");
                                }
                                catch(MessagingException mex)
                                {
                                        System.out.println( "FetchMail.cp2Inbox() :: caught MessagingException" ) ;
                                        mex = new MessagingException(mex.getMessage());
                                }
                        }
                }
                return mailbs[0];
        }
 
        public static Message [] getMails(Account acc)
        {
                FetchMail fm = new FetchMail(acc);
                return fm.messages;
        }
        public static Folder [] getMailboxes(Account acc)
        {
                FetchMail fm = new FetchMail(acc);
                return fm.mailboxes;
        }
 
        public static void main(String [] args)
        {
                //Account acc = new Account("ich","123456","pop3","smtp","mail.inf.fu-berlin.de");
                //FetchMail bluubs = new FetchMail(acc);
        }
}
>>>>>>> 1.8*/
