package smail.utils ;
/**
 *This class wraps the information about a changed property which is propagated
 *to the PropertyChanged-Listeners.
 */

public class PropertyChangedEvent
{
	private String key ;
	private String value ;
	
	public PropertyChangedEvent(String key, String value)
	{
		this.key = key ;
		this.value = value ;
	}
	
	public String getKey()
	{	return(this.key);
	}
	
	public String getValue()
	{	return(this.value);
	}
}
