package smail;

import javax.swing.* ;
import java.awt.* ;
import java.awt.event.* ;

public class Popup extends JDialog {
	private JLabel label ;

	Popup(String m) {
		super(new JDialog() , "Fassadenrckmeldung:", true ) ;
		this.setBounds(250,250,400,100) ;
		this.addWindowListener( new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0) ;
			}
		}) ;

		Container cp = this.getContentPane() ;
		cp.setLayout(new GridBagLayout()) ;

		GridBagConstraints c = new GridBagConstraints() ;

		c.insets = new Insets(10,10,10,10) ;
		c.gridx = 1 ; 
		c.gridy = 1 ;
		c.gridwidth = 1 ;
		c.gridheight = 1 ;
		JButton b = new JButton("Close") ;
		cp.add(b,c) ;
		//		b.addActionListener( new ActionListener ()
		//		{
		//			public void actionPerformed (ActionEvent e)
		//			{
		//				System.exit(0) ;
		//			}
		//		
		//		}) ;

		c.gridx = 0 ;
		c.gridy = 0 ;
		c.gridwidth = 3 ;
		c.gridheight = 1 ;
		JLabel f = new JLabel("Die Methode "+m+" wurde aufgerufen !") ;
		cp.add(f,c) ;
	}

	public Popup(String message , boolean modal) {
		super(new JDialog(), "smail - Message",true ) ;
		((JPanel)getContentPane()).setBorder(new javax.swing.border.EmptyBorder(20,20,20,20));
		getContentPane().setLayout(new GridBagLayout()) ;
		GridBagConstraints c = new GridBagConstraints() ;
		c.gridx 	= 0 ;
		c.gridy		= 0 ;
		c.gridwidth	= 1 ;
		c.gridheight = 1 ;
		JLabel label = new JLabel(message) ;
		label.setFont(new java.awt.Font("dialog",1,14)) ;
		label.setBorder(BorderFactory.createEmptyBorder(30,30,30,30)) ;
		getContentPane().add(label,c) ;
		JButton ok = new JButton("close") ;
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose() ;
			}
		}) ;
		c.gridy 	= 1 ;
		getContentPane().add(ok, c) ;
		pack() ;
		setPosition() ;
		show() ;
	}

	public Popup(String[] message , boolean modal) {
		super(new JDialog(), "smail - Message",true ) ;
		((JPanel)getContentPane()).setBorder(new javax.swing.border.EmptyBorder(20,20,20,20));
		getContentPane().setLayout(new GridBagLayout()) ;


		GridBagConstraints c = new GridBagConstraints() ;
		c.gridx 	= 0 ;
		c.gridy		= 0 ;
		c.gridwidth	= 1 ;
		c.gridheight = 1 ;

		if (message == null || message.length <= 0) {
			return ;
		}

		JLabel[] labels = new JLabel[message.length] ;
		int labelCount = 0 ;
		for (; labelCount < message.length ; labelCount++ ) {
			labels[labelCount] = new JLabel(message[labelCount]) ;
			labels[labelCount].setFont(new java.awt.Font("dialog",1,12)) ;
			c.gridx	= 0 ;
			c.gridy = labelCount+1 ;
			getContentPane().add(labels[labelCount],c) ;

		}

		JButton ok = new JButton("close") ;
		ok.setPreferredSize(new Dimension(70,25)) ;
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose() ;
			}
		}) ;
		c.gridy 	= labelCount+1 ;
		c.insets = new Insets(20,20,0,20) ;
		getContentPane().add(ok, c) ;
		pack() ;
		setPosition() ;
		show() ;
	}


	private void setPosition() {
		/* mit dank geklaut */
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
	}	

}

