package smail.gui;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;

public class Internet extends JFrame
{
    JTextField enter;
    JEditorPane contents;
    //JButton  button_edit ;
    JPanel  panel_in ;
    JPanel  panel_out ;
    Font font;

    public  Internet(String sHyperlink)
    {
        super( "Sm@il - Browser");

        Image image = new ImageIcon(getClass().getResource("Images/icon16.png")).getImage();
        this.setIconImage(image);


        panel_in = new JPanel();
        //panel_in.setBackground(Color.pink);

        //button_edit = new JButton("edit page") ;
        //button_edit.addActionListener(this);
        panel_in.setBorder(BorderFactory.createEtchedBorder());

        getContentPane().add("North" , panel_in );

        enter = new JTextField( sHyperlink , 30 );
        enter.addActionListener(
          new ActionListener() {
            public void actionPerformed( ActionEvent e )
            {
               getThePage(e.getActionCommand());
            }
          }
        );

        panel_in.add(enter);
        //panel_in.add(button_edit);

        Component panel1 = makeoutPanel();

        setSize( 700, 700 );
        show();
   }

    public void show(String sUrl)
    {
      this.show();
      this.getThePage(sUrl);
    }

    protected Component makeoutPanel() {

    panel_out = new JPanel() ;
    contents = new JEditorPane();
    font = new Font("SansSerif",Font.BOLD,17);
    contents.setFont(font);
    panel_out.setLayout(new BorderLayout());
    getContentPane().add("Center" , panel_out);
    contents.setEditable( false );

    contents.addHyperlinkListener(
         new HyperlinkListener() {
            public void hyperlinkUpdate( HyperlinkEvent e )
            {
               if ( e.getEventType() ==
                    HyperlinkEvent.EventType.ACTIVATED )
                  getThePage( e.getURL().toString() );
            }
         }
      );

    panel_out.add( new JScrollPane( contents ),
             BorderLayout.CENTER );

           return panel_out ;

  }






 ////////////////////////////////////(((((()))))))//////////////////////////
  /*  public void actionPerformed(ActionEvent event){
     Object source = event.getSource();
     if (source == button_edit) {
     	 contents.setEditable( true );
     	 Component panel3 = makeoutPanel();

     	  }
     } */
//////////////////((((((((((()))))))))))))))/////////////////////////////////


   private void getThePage( String location )
   {
      setCursor( Cursor.getPredefinedCursor(
                    Cursor.WAIT_CURSOR ) );

      try {

         contents.setPage( location );
         enter.setText( location );
      }
      catch ( IOException io ) {
         JOptionPane.showMessageDialog( this,
            "Error retrieving specified URL",
            "Bad URL",
            JOptionPane.ERROR_MESSAGE );
      }

      setCursor( Cursor.getPredefinedCursor(
                    Cursor.DEFAULT_CURSOR ) );
   }

   public static void main( String args[] )
   {
      Internet  app = new Internet("test");

      app.addWindowListener(
         new WindowAdapter() {
            public void windowClosing( WindowEvent e )
            {
               System.exit( 0 );
            }
         }
      );
   }
}



