package smail.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.color.*;
import javax.swing.border.*;
import java.util.*;

/**
 * used to add a new group to the addressbook
 * 
 *
 */
public class PassWordEnter extends JDialog {
    
    private ResourceBundle resourceB = ResourceBundle.getBundle("smail/gui/PassWord_lang");

    private String commitPwdString = resourceB.getString("commitPwdString_key");
    private String labPwdString = resourceB.getString("labPwdString_key");
    private String closeButtonString = resourceB.getString("closeButtonString_key");
    private String titelString ;

    private JPanel mainPanel = new JPanel();

    private JPanel groupPanel = new JPanel();
    private JPanel buttonPanel = new JPanel();
    private JPanel downPanel = new JPanel();
	private JLabel accountName ;
    private JButton commitPwd = new JButton(commitPwdString);
    private JButton closeButton = new JButton(closeButtonString);
    
    //private JLabel labPwd = new JLabel(labPwdString);
    char[] password = new char[0];
    
    private JPasswordField jPF1 = new JPasswordField(20);
  
    private TitledBorder titleBorder;
    private PassWordEnter pwe;
    private smail.server.Account account;

    
    public PassWordEnter(smail.server.Account acc) { 
	
	
	super(new JDialog(), true );
		this.account = acc;
        pwe = this;
        titelString = account.accountName;
//        frame = new JFrame();
	getContentPane().setLayout(new GridLayout(0,1));
	getContentPane().add(mainPanel);
	
	mainPanel.setLayout(new BorderLayout());
	mainPanel.add(BorderLayout.CENTER, groupPanel);
	mainPanel.add(BorderLayout.SOUTH,downPanel);

	downPanel.setLayout(new BorderLayout());
	downPanel.add(BorderLayout.EAST,buttonPanel);

	titleBorder = BorderFactory.createTitledBorder(titelString);
	groupPanel.setBorder(titleBorder);
	groupPanel.setLayout(new BorderLayout());

	groupPanel.add(BorderLayout.CENTER,jPF1);

	buttonPanel.setLayout(new GridLayout(1,2));
	buttonPanel.add(commitPwd);
	buttonPanel.add(closeButton);
	


	commitPwd.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
    			char[] password = jPF1.getPassword();
				account.password = new String(password);
    			System.out.println ("das Passwort wurde eingegeben");
				dispose();
   		}});

	
	closeButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    dispose();
		}});

        addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    dispose();
		}
	    });

        pack();
        show();

    } 
    /* end of construuctor */
}
/* end of class AddGroup */
