package smail.gui.filterGui ;

import javax.swing.* ;
import javax.swing.table.* ;
import java.awt.event.* ;
import java.awt.* ;
import smail.filter.* ;

class ConditionDialog extends JDialog
{
	Condition cond ;
	
	private JLabel			newCondLabel	= new JLabel("define a new condition :") ;
	private JRadioButton 	dateRB 			= new JRadioButton("Date :") ;
	private JRadioButton 	fromRB 			= new JRadioButton("From :") ;
	private JRadioButton 	subjectRB 		= new JRadioButton("Subject :") ;
	private ButtonGroup 	condTypeGroup 	= new ButtonGroup() ;
	private JComboBox 		dateCB ;
	private JTextField 		fromF 			= new JTextField() ;
	private JTextField 		dateF 			= new JTextField() ;
	private JTextField 		subjectF 		= new JTextField() ;
	private JButton 		addB 			= new JButton("add this...") ;
	private JButton			cancelB			= new JButton("cancel") ;
	private Container		cp ;
	private Color active ;
	private Color inactive ;
//	private FGAddWizzard addWiz ;


	private boolean isactive = true ;
	
	ConditionDialog(JFrame owner)
	{
		super(owner, "smail - define a condition", true) ;

		initConditionDialog() ;
//		validate() ;
		pack() ;
		inactive = cp.getBackground() ;
		active = dateF.getBackground() ;
		
//		show() ;
	}
	
	
	private void initConditionDialog()
	{
		cp = getContentPane() ;
		((JPanel)cp).setBorder(new javax.swing.border.EmptyBorder(20,20,20,20)) ;
		cp.setLayout(new GridBagLayout()) ;
		GridBagConstraints c = new GridBagConstraints() ;
		c.insets = new Insets(4,4,4,4) ;


		c.gridx			= 0 ;
		c.gridy			= 0 ;
		c.gridwidth		= 3 ;
		c.gridheight	= 1 ;
		cp.add(newCondLabel, c) ;
		
		/* add irgendwas  */
		condTypeGroup.add(dateRB) ;
		condTypeGroup.add(fromRB) ;
		condTypeGroup.add(subjectRB) ;


		/* "date" part */
		dateRB.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					dateF.setEnabled(true) ;
					dateF.setBackground(active) ;
					fromF.setEnabled(false) ;
					fromF.setBackground(inactive) ;
					subjectF.setEnabled(false) ;
					subjectF.setBackground(inactive) ;
/*DEBUG*/			System.out.println( " set" ) ;
/*DEBUG*/			System.out.println( "date RB pressed" ) ;
				}
			}) ;
		c.gridx 		= 0 ;
		c.gridy 		= 1 ;
		c.gridwidth		= 1 ;
		c.gridheight	= 1 ;
		c.anchor 		= GridBagConstraints.WEST ;
		cp.add(dateRB, c) ;

		/* from part */
		fromRB.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					fromF.setEnabled(true) ;
					fromF.setBackground(active) ;
					dateF.setEnabled(false) ;
					dateF.setBackground(inactive) ;
					subjectF.setEnabled(false) ;
					subjectF.setBackground(inactive) ;
/*DEBUG*/					System.out.println( "inactive was set" ) ;
/*DEBUG*/					System.out.println( "from RB pressed" ) ;
				}
			}) ;
		c.gridx 		= 0 ;
		c.gridy 		= 3 ;
		c.gridwidth 	= 1 ;
		c.gridheight 	= 1 ;
		cp.add(fromRB, c );

		/* subject part */
		subjectRB.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					subjectF.setEnabled(true) ;
					subjectF.setBackground(active) ;
					fromF.setEnabled(false) ;
					fromF.setBackground(inactive) ;
					dateF.setEnabled(false) ;
					dateF.setBackground(inactive) ;
/*DEBUG*/					System.out.println( "inactive was set" ) ;
/*DEBUG*/					System.out.println( "subject rb pressed" ) ;
				}
			}) ;
		c.gridx 		= 0 ;
		c.gridy			= 4 ;
		c.gridwidth 	= 1 ;
		c.gridheight 	= 1 ;
		cp.add(subjectRB, c) ;

		String[] dateTypeList = new String[] 
		{ "please select" , "date is equal" , "newer than" , "older than" } ;

		dateCB = new JComboBox(dateTypeList) ;
		dateCB.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					dateRB.setSelected(true) ;
					dateF.setEnabled(true) ;
					dateF.setBackground(active) ;
					fromF.setEnabled(false) ;
					fromF.setBackground(inactive) ;
					subjectF.setEnabled(false) ;
					subjectF.setBackground(inactive) ;
/*DEBUG*/					System.out.println( "inactive was set" ) ;
/*DEBUG*/					System.out.println( "comboBox" ) ;
				}
			}) ;

		c.gridx			= 1 ;
		c.gridy			= 1 ;
		c.gridwidth		= 1 ;
		c.gridheight	= 1 ;
		c.weightx 		= 1.0 ;
		cp.add(dateCB, c) ;


		fromF.addFocusListener(new FocusListener()
				{
					public void focusGained(FocusEvent e)
					{
/*DEBUG*/						System.out.println( "fromfield" ) ;
						// set the "move" radiobutton
						fromRB.setSelected(true) ;
						subjectF.setEnabled(false) ;
						subjectF.setBackground(inactive) ;
						dateF.setEnabled(false) ;
						dateF.setBackground(inactive) ;
/*DEBUG*/					System.out.println( "inactive was set" ) ;
					}
					public void focusLost(FocusEvent e){}
				}) ;
		c.gridx 		= 1 ;
		c.gridy 		= 3 ;
		c.gridwidth 	= 2 ;
		c.gridheight 	= 1 ;
		c.fill			= GridBagConstraints.HORIZONTAL ;
		c.anchor 		= GridBagConstraints.CENTER ;
		cp.add(fromF, c) ;

		dateF.addFocusListener(new FocusListener()
				{
					public void focusGained(FocusEvent e)
					{
/*DEBUG*/						System.out.println( "date field" ) ;
						// set the "move" radiobutton
						dateRB.setSelected(true) ;
						fromF.setEnabled(false) ;
						fromF.setBackground(inactive) ;
						subjectF.setEnabled(false) ;
						subjectF.setBackground(inactive) ;								
/*DEBUG*/					System.out.println( "inactive was set" ) ;
					}
					public void focusLost(FocusEvent e){}
				}) ;
		c.gridx			= 1 ;
		c.gridy			= 2 ;
		c.gridwidth		= 2 ;
		c.gridheight	= 1 ;
		cp.add(dateF, c) ;

		subjectF.addFocusListener(new FocusListener()
				{
					public void focusGained(FocusEvent e)
					{
/*DEBUG*/						System.out.println( "subject field" ) ;
						// set the "move" radiobutton
						subjectRB.setSelected(true) ;
						fromF.setEnabled(false) ;
						fromF.setBackground(inactive) ;
						dateF.setEnabled(false) ;
						dateF.setBackground(inactive) ;								
/*DEBUG*/					System.out.println( "inactive was set" ) ;
					}
					public void focusLost(FocusEvent e){}
				}) ;
		c.gridx 		= 1 ;
		c.gridy			= 4 ;
		c.gridwidth 	= 2 ;
		c.gridheight 	= 1 ;
		cp.add(subjectF, c) ;

		addB.setPreferredSize(new Dimension(120,30)) ;
		addB.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					//compute the condition type and add it to cond[] in tableModel
/*DEBUG*/					System.out.println( "add this button " ) ;
					if (dateRB.isSelected())
					{
/*DEBUG*/						System.out.println( "add this : date sel" ) ;
						makeDateCondition() ;
					}
					else if (fromRB.isSelected())
					{
/*DEBUG*/						System.out.println( "add this : from sel ") ;
						makeFromCondition() ;
					}
					else if (subjectRB.isSelected())
					{
/*DEBUG*/						System.out.println( "add this : subject sel" ) ;
						makeSubjectCondition() ;
					}
					else
					{
						System.out.println( "none is selected" ) ;
						smail.Popup p = new smail.Popup("Please choose a Condition-Type",true) ;
					}
				}
			}) ;
		c.fill			= GridBagConstraints.NONE ;
		c.gridx 		= 1 ;
		c.gridy			= 5 ;
		c.gridwidth		= 1 ;
		c.gridheight	= 1 ;
		cp.add(addB, c) ;
		
		cancelB.setPreferredSize(new Dimension(120,30)) ;
		cancelB.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					dispose() ;
				}
			}) ;
		c.gridx			= 2 ;
		c.gridy			= 5 ;
		c.gridwidth		= 1 ;
		c.gridheight	= 1 ;
		cp.add(cancelB, c) ;
		
		
	}
	
	Condition getCondition()
	{
		return cond ;
	}
		
	private void makeSubjectCondition()
	{
/*DEBUG*/		System.out.print( "make subjectCondition ::") ;
		String subject = subjectF.getText() ;
		if (subject.equals(""))
		{
			smail.Popup p = new smail.Popup("Please enter a text part to match mails to !",true) ;
			return ;
		}
		cond = new SubjectCondition(subject) ;
/*DEBUG*/		System.out.println( "ist cond gleich null ? "+(this.cond == null) ) ;
		tellWindowClosing() ;
		dispose() ;
		
	}
		
	private void makeFromCondition()
	{
/*DEBUG*/		System.out.print( "make FromCondition ::" ) ;
		String from = fromF.getText() ;
		if (from.equals(""))
		{
			smail.Popup p = new smail.Popup("Please enter an address !",true) ;
			return ;
		}
		cond = new FromCondition(from) ;
/*DEBUG*/		System.out.println( "ist cond gleich null ? "+(this.cond == null) ) ;
		tellWindowClosing() ;
		dispose() ;
	}
	
	private void makeDateCondition()
	{
/*DEBUG*/		System.out.print( "make DateCondition ::" ) ;
		int type = -1 ;
		String date = dateF.getText() ;	 
		java.util.Date realDate ;
		if (date.equals(""))
		{
			smail.Popup p = new smail.Popup("Please enter a date !",true) ;
			return  ;
		}
		try
		{
			java.text.DateFormat dateFormat = java.text.DateFormat.getInstance() ;
			realDate = dateFormat.parse(date) ;
		}
		catch (java.text.ParseException pe)
		{
			smail.Popup p = new smail.Popup("Date has invalid format !",true) ;
			return  ;								
		}
		int dateSelection = dateCB.getSelectedIndex() ;
		try
		{
			if (dateSelection == 1)
			{	
				cond = new DateCondition(smail.filter.DateCondition.EQUALS, realDate) ;
			}
			else if (dateSelection == 2)
			{
				cond = new DateCondition(smail.filter.DateCondition.NEWER, realDate) ;
			}
			else if (dateSelection == 3)
			{
				cond = new DateCondition(smail.filter.DateCondition.OLDER, realDate) ;
			}
			else
			{
				System.out.println( "invalid date type selection" ) ;
				return  ;// DEAD CODE
			}
			System.out.println( "ist cond gleich null ? "+(this.cond == null) ) ;
			tellWindowClosing() ;
			dispose() ;
		}
		catch (NoSuchTypeException nste)
		{
			System.out.println( "ConditionDialog.makeDateCondition() :: nosuchtype geworfen ??" ) ;
		}
	}

	private void tellWindowClosing()
	{
	processWindowEvent(new WindowEvent(this,WindowEvent.WINDOW_CLOSING) ) ;
}
	
}