/*
 * PGP.java
 *
 * Created on 14. Juli 2001, 11:50
 */

package smail.utils;

/**
 *
 * @author  reb
 * @version 
 */
public class PGP extends java.lang.Object {

    public static smail.localStore.LocalMessage encrypt(smail.localStore.LocalMessage lm) throws java.io.FileNotFoundException, java.io.IOException, javax.mail.MessagingException
    {
        java.io.FileWriter fw = new java.io.FileWriter(new java.io.File("temp"+java.io.File.separator+"pgp"));
        fw.write((String)lm.getContent());
        fw.flush();
        
        //java.io.FileOutputStream fOs = new java.io.FileOutputStream("temp.pgp");
        //lm.writeTo(fOs);
        //fOs.flush();
        
        String commandLine = "pgp -ea +force temp.pgp"+lm.getRecipients(javax.mail.Message.RecipientType.TO)[0];
        System.out.println(commandLine);
        Process ps = java.lang.Runtime.getRuntime().exec(commandLine);
        
        // the output stream
        java.io.PrintWriter psOutputPrintWriter = new java.io.PrintWriter(ps.getOutputStream());
        
        //the input stream
        java.io.BufferedReader psInputBuffReader = new java.io.BufferedReader(new java.io.InputStreamReader(ps.getInputStream()));
        
        // the error stream
        java.io.BufferedReader psErrorBuff = new java.io.BufferedReader(new java.io.InputStreamReader(ps.getErrorStream()));
        
        String line=null;
        while ((line = psErrorBuff.readLine()) != null)
        {
            System.out.println("PGP Error Stream: "+line);
        }

        String text="";
        while ((line = psInputBuffReader.readLine()) != null)
        {
            text=text+line;
        }
        //javax.mail.Multipart tempMultipart = new javax.mail.Multipart();
        
        lm.setContent(text, "text/plain");
        
        System.out.println("exitValue PGP: "+ps.exitValue());
        
        psOutputPrintWriter.close();
        psInputBuffReader.close();
        psErrorBuff.close();
        
        return lm;
    }

    public static smail.localStore.LocalMessage decrypt(smail.localStore.LocalMessage lm) throws java.io.FileNotFoundException, java.io.IOException, javax.mail.MessagingException
    {
        java.io.FileWriter fw = new java.io.FileWriter(new java.io.File("temp"+java.io.File.separator+"pgp"));
        fw.write((String)lm.getContent());
        fw.flush();
        
        //java.io.FileOutputStream fOs = new java.io.FileOutputStream("temp.pgp");
        //lm.writeTo(fOs);
        //fOs.flush();
        
        String commandLine = "pgp +force temp.pgp"+lm.getRecipients(javax.mail.Message.RecipientType.TO)[0];
        System.out.println(commandLine);
        Process ps = java.lang.Runtime.getRuntime().exec(commandLine);
        
        // the output stream
        java.io.PrintWriter psOutputPrintWriter = new java.io.PrintWriter(ps.getOutputStream());
        
        //the input stream
        java.io.BufferedReader psInputBuffReader = new java.io.BufferedReader(new java.io.InputStreamReader(ps.getInputStream()));
        
        // the error stream
        java.io.BufferedReader psErrorBuff = new java.io.BufferedReader(new java.io.InputStreamReader(ps.getErrorStream()));
        
        String line=null;
        while ((line = psErrorBuff.readLine()) != null)
        {
            System.out.println("PGP Error Stream: "+line);
        }

        String text="";
        while ((line = psInputBuffReader.readLine()) != null)
        {
            text=text+line;
        }
        //javax.mail.Multipart tempMultipart = new javax.mail.Multipart();
        
        lm.setContent(text, "text/plain");
        
        System.out.println("exitValue PGP: "+ps.exitValue());
        
        psOutputPrintWriter.close();
        psInputBuffReader.close();
        psErrorBuff.close();
        
        return lm;
    }
        
    public static boolean isEncrypted(smail.localStore.LocalMessage lm) throws java.io.IOException, javax.mail.MessagingException
    {
        String text = (String)lm.getContent();
        if (text.lastIndexOf("-----BEGIN PGP MESSAGE-----")==0)
            return false;
        else
            return true;
    }
}
